commit 7170957a90568bfc5ea0451a7aca9b5d11f50331
Author: Alexander Barkov <bar@mariadb.org>
Date:   Thu Dec 15 11:15:52 2016 +0400

    MDEV-11514, MDEV-11497, MDEV-11554, MDEV-11555 - IN and CASE type aggregation problems
    
    This patch fixes a number of data type aggregation problem in IN and CASE:
    - MDEV-11497 Wrong result for (int_expr IN (mixture of signed and unsigned expressions))
    - MDEV-11514 IN with a mixture of TIME and DATETIME returns a wrong result
    - MDEV-11554 Wrong result for CASE on a mixture of signed and unsigned expressions
    - MDEV-11555 CASE with a mixture of TIME and DATETIME returns a wrong result
    
    1. The problem reported in MDEV-11514 and MDEV-11555 was in the wrong assumption
    that items having the same cmp_type() can reuse the same cmp_item instance.
    So Item_func_case and Item_func_in used a static array of cmp_item*,
    one element per one XXX_RESULT.
    
    TIME and DATETIME cannot result the same cmp_item, because arguments of
    these types are compared very differently. TIME and DATETIME must have
    different instances in the cmp_item* array. Reusing the same cmp_item
    for TIME and DATETIME leads to unexpected result and unexpected warnings.
    
    Note, after adding more data types soon (e.g. INET6), the problem would
    become more serious, as INET6 will most likely have STRING_RESULT, but
    it cannot reuse the same cmp_item with VARCHAR/TEXT.
    
    This patch introduces a new class Predicant_to_list_comparator,
    which maintaince an array of cmp_items, one element per distinct
    Type_handler rather than one element per XXX_RESULT.
    
    2. The problem reported in MDEV-11497 and MDEV-11554 happened because
    Item_func_in and Item_func_case did not take into account the fact
    that UNSIGNED and SIGNED values must be compared as DECIMAL rather than INT,
    because they used item_cmp_type() to aggregate the arguments.
    The relevant code now resides in Predicant_to_list_comparator::add_value()
    and uses Type_handler_hybrid_field_type::aggregate_for_comparison(),
    like Item_func_between does.

diff --git a/mysql-test/r/case.result b/mysql-test/r/case.result
index 9ceb7ef..ba38f26 100644
--- a/mysql-test/r/case.result
+++ b/mysql-test/r/case.result
@@ -379,3 +379,34 @@ DROP TABLE t1;
 #
 # End of 10.1 test
 #
+#
+# Start of 10.3 tests
+#
+#
+# MDEV-11554 Wrong result for CASE on a mixture of signed and unsigned expressions
+#
+CREATE TABLE t1 (a BIGINT, b BIGINT UNSIGNED);
+INSERT INTO t1 VALUES (-9223372036854775808,18446744073709551615);
+SELECT
+CASE -1
+WHEN -9223372036854775808 THEN 'one'
+    WHEN 18446744073709551615 THEN 'two'
+  END AS c;
+c
+NULL
+DROP TABLE t1;
+#
+# MDEV-11555 CASE with a mixture of TIME and DATETIME returns a wrong result
+#
+SELECT
+CASE TIME'10:20:30'
+    WHEN 102030 THEN 'one'
+    WHEN TIME'10:20:31' THEN 'two'
+  END AS good,
+CASE TIME'10:20:30'
+    WHEN 102030 THEN 'one'
+    WHEN TIME'10:20:31' THEN 'two'
+    WHEN TIMESTAMP'2001-01-01 10:20:32' THEN 'three'
+  END AS was_bad_now_good;
+good	was_bad_now_good
+one	one
diff --git a/mysql-test/r/func_debug.result b/mysql-test/r/func_debug.result
index 662c7cd..b1a3260 100644
--- a/mysql-test/r/func_debug.result
+++ b/mysql-test/r/func_debug.result
@@ -1,270 +1,475 @@
 SET SESSION debug_dbug="+d,Item_func_in";
+SET SESSION debug_dbug="+d,Predicant_to_list_comparator";
 # Constant predicant, compatible types, bisect
 SELECT 1 IN (1,2);
 1 IN (1,2)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1 IN (1,2,NULL);
 1 IN (1,2,NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1 NOT IN (1,2);
 1 NOT IN (1,2)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1 NOT IN (1,2,NULL);
 1 NOT IN (1,2,NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1.0 IN (1.0,2.0);
 1.0 IN (1.0,2.0)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1.0 IN (1.0,2.0,NULL);
 1.0 IN (1.0,2.0,NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1.0 NOT IN (1.0,2.0);
 1.0 NOT IN (1.0,2.0)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1.0 NOT IN (1.0,2.0,NULL);
 1.0 NOT IN (1.0,2.0,NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1e0 IN (1e0,2e0);
 1e0 IN (1e0,2e0)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1e0 IN (1e0,2e0,NULL);
 1e0 IN (1e0,2e0,NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1e0 NOT IN (1e0,2e0);
 1e0 NOT IN (1e0,2e0)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 1e0 NOT IN (1e0,2e0,NULL);
 1e0 NOT IN (1e0,2e0,NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 'a' IN ('a','b');
 'a' IN ('a','b')
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 'a' IN ('a','b',NULL);
 'a' IN ('a','b',NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 'a' NOT IN ('a','b');
 'a' NOT IN ('a','b')
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT 'a' NOT IN ('a','b',NULL);
 'a' NOT IN ('a','b',NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIMESTAMP'2001-01-01 10:20:30' IN ('2001-01-01 10:20:30','2001-02-02 10:20:30');
 TIMESTAMP'2001-01-01 10:20:30' IN ('2001-01-01 10:20:30','2001-02-02 10:20:30')
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIMESTAMP'2001-01-01 10:20:30' IN ('2001-01-01 10:20:30','2001-02-02 10:20:30',NULL);
 TIMESTAMP'2001-01-01 10:20:30' IN ('2001-01-01 10:20:30','2001-02-02 10:20:30',NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIMESTAMP'2001-01-01 10:20:30' NOT IN ('2001-01-01 10:20:30','2001-02-02 10:20:30');
 TIMESTAMP'2001-01-01 10:20:30' NOT IN ('2001-01-01 10:20:30','2001-02-02 10:20:30')
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIMESTAMP'2001-01-01 10:20:30' NOT IN ('2001-01-01 10:20:30','2001-02-02 10:20:30',NULL);
 TIMESTAMP'2001-01-01 10:20:30' NOT IN ('2001-01-01 10:20:30','2001-02-02 10:20:30',NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIME'10:20:30' IN ('10:20:30','10:20:30');
 TIME'10:20:30' IN ('10:20:30','10:20:30')
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIME'10:20:30' IN ('10:20:30','10:20:30',NULL);
 TIME'10:20:30' IN ('10:20:30','10:20:30',NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIME'10:20:30' NOT IN ('10:20:30','10:20:30');
 TIME'10:20:30' NOT IN ('10:20:30','10:20:30')
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT TIME'10:20:30' NOT IN ('10:20:30','10:20:30',NULL);
 TIME'10:20:30' NOT IN ('10:20:30','10:20:30',NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT DATE'2001-01-01' IN ('2001-01-01','2001-02-02');
 DATE'2001-01-01' IN ('2001-01-01','2001-02-02')
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT DATE'2001-01-01' IN ('2001-01-01','2001-02-02',NULL);
 DATE'2001-01-01' IN ('2001-01-01','2001-02-02',NULL)
 1
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT DATE'2001-01-01' NOT IN ('2001-01-01','2001-02-02');
 DATE'2001-01-01' NOT IN ('2001-01-01','2001-02-02')
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT DATE'2001-01-01' NOT IN ('2001-01-01','2001-02-02',NULL);
 DATE'2001-01-01' NOT IN ('2001-01-01','2001-02-02',NULL)
 0
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 # Column predicant, compatible types, bisect
+CREATE TABLE t1 (a INT UNSIGNED);
+SELECT a IN (1.0, 1) FROM t1;
+a IN (1.0, 1)
+Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	types_compatible=yes bisect=yes
+DROP TABLE t1;
 CREATE TABLE t1 (a INT);
 SELECT a IN (1,2,3) FROM t1;
 a IN (1,2,3)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN (1,2,3,NULL) FROM t1;
 a IN (1,2,3,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	types_compatible=yes bisect=yes
+SELECT a IN (1.0, CAST(1 AS UNSIGNED)) FROM t1;
+a IN (1.0, CAST(1 AS UNSIGNED))
+Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	types_compatible=yes bisect=yes
+SELECT a IN (1.0, CAST(1 AS UNSIGNED),NULL) FROM t1;
+a IN (1.0, CAST(1 AS UNSIGNED),NULL)
+Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1,2,3) FROM t1;
 a NOT IN (1,2,3)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1,2,3,NULL) FROM t1;
 a NOT IN (1,2,3,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	types_compatible=yes bisect=yes
+SELECT a NOT IN (1.0, CAST(1 AS UNSIGNED)) FROM t1;
+a NOT IN (1.0, CAST(1 AS UNSIGNED))
+Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	types_compatible=yes bisect=yes
+SELECT a NOT IN (1.0, CAST(1 AS UNSIGNED),NULL) FROM t1;
+a NOT IN (1.0, CAST(1 AS UNSIGNED),NULL)
+Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a DOUBLE);
 SELECT a IN (1e0,2,3.0) FROM t1;
 a IN (1e0,2,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN (1e0,2,3.0,NULL) FROM t1;
 a IN (1e0,2,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1e0,2,3.0) FROM t1;
 a NOT IN (1e0,2,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1e0,2,3.0,NULL) FROM t1;
 a NOT IN (1e0,2,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a DECIMAL(10,1));
 SELECT a IN (1,2.0,3.0) FROM t1;
 a IN (1,2.0,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN (1,2.0,3.0,NULL) FROM t1;
 a IN (1,2.0,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1,2.0,3.0) FROM t1;
 a NOT IN (1,2.0,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN (1,2.0,3.0,NULL) FROM t1;
 a NOT IN (1,2.0,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a VARCHAR(10));
 SELECT a IN ('a','b','c') FROM t1;
 a IN ('a','b','c')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN ('a','b','c',NULL) FROM t1;
 a IN ('a','b','c',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('a','b','c') FROM t1;
 a NOT IN ('a','b','c')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('a','b','c',NULL) FROM t1;
 a NOT IN ('a','b','c',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a DATE);
 SELECT a IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0) FROM t1;
 a IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0,NULL) FROM t1;
 a IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0) FROM t1;
 a NOT IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0,NULL) FROM t1;
 a NOT IN ('2001-01-01',DATE'2001-01-02',20010102,20010102.0,20010102e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a TIME);
 SELECT a IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0) FROM t1;
 a IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0,NULL) FROM t1;
 a IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0) FROM t1;
 a NOT IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0,NULL) FROM t1;
 a NOT IN ('10:20:30',TIME'10:20:30',102030,102030.0,102030e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 CREATE TABLE t1 (a DATETIME);
 SELECT a IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0) FROM t1;
 a IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
+Warning	1105	[5] arg=6 handler=0
+Warning	1105	[6] arg=7 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0,NULL) FROM t1;
 a IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
+Warning	1105	[5] arg=6 handler=0
+Warning	1105	[6] arg=7 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0) FROM t1;
 a NOT IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
+Warning	1105	[5] arg=6 handler=0
+Warning	1105	[6] arg=7 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 SELECT a NOT IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0,NULL) FROM t1;
 a NOT IN ('2001-01-01',TIMESTAMP'2001-01-01 10:20:30',DATE'2001-01-01',TIME'10:20:30',20010101102030,20010101102030.0,20010101102030e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
+Warning	1105	[4] arg=5 handler=0
+Warning	1105	[5] arg=6 handler=0
+Warning	1105	[6] arg=7 handler=0
 Warning	1105	types_compatible=yes bisect=yes
 DROP TABLE t1;
 # Constant predicant, compatible types, no bisect
@@ -273,126 +478,210 @@ CREATE TABLE t1 (a INT);
 SELECT 1 IN (a,1,2,3) FROM t1;
 1 IN (a,1,2,3)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 IN (a,1,2,3,NULL) FROM t1;
 1 IN (a,1,2,3,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1,2,3) FROM t1;
 1 NOT IN (a,1,2,3)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1,2,3,NULL) FROM t1;
 1 NOT IN (a,1,2,3,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a DOUBLE);
 SELECT 1 IN (a,1e0,2e0,3e0) FROM t1;
 1 IN (a,1e0,2e0,3e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 IN (a,1e0,2e0,3e0,NULL) FROM t1;
 1 IN (a,1e0,2e0,3e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1e0,2e0,3e0) FROM t1;
 1 NOT IN (a,1e0,2e0,3e0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1e0,2e0,3e0,NULL) FROM t1;
 1 NOT IN (a,1e0,2e0,3e0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a DECIMAL(10,1));
 SELECT 1 IN (a,1.0,2.0,3.0) FROM t1;
 1 IN (a,1.0,2.0,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 IN (a,1.0,2.0,3.0,NULL) FROM t1;
 1 IN (a,1.0,2.0,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1.0,2.0,3.0) FROM t1;
 1 NOT IN (a,1.0,2.0,3.0)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 1 NOT IN (a,1.0,2.0,3.0,NULL) FROM t1;
 1 NOT IN (a,1.0,2.0,3.0,NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
+Warning	1105	[3] arg=4 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a VARCHAR(10));
 SELECT 'a' IN (a,'b','c') FROM t1;
 'a' IN (a,'b','c')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 'a' IN (a,'b','c',NULL) FROM t1;
 'a' IN (a,'b','c',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 'a' NOT IN (a,'b','c') FROM t1;
 'a' NOT IN (a,'b','c')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT 'a' NOT IN (a,'b','c',NULL) FROM t1;
 'a' NOT IN (a,'b','c',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
+Warning	1105	[2] arg=3 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a DATE);
 SELECT DATE'2001-01-01' IN (a,'2001-01-01') FROM t1;
 DATE'2001-01-01' IN (a,'2001-01-01')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT DATE'2001-01-01' IN (a,'2001-01-01',NULL) FROM t1;
 DATE'2001-01-01' IN (a,'2001-01-01',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT DATE'2001-01-01' NOT IN (a,'2001-01-01') FROM t1;
 DATE'2001-01-01' NOT IN (a,'2001-01-01')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT DATE'2001-01-01' NOT IN (a,'2001-01-01',NULL) FROM t1;
 DATE'2001-01-01' NOT IN (a,'2001-01-01',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a TIME);
 SELECT TIME'10:20:30' IN (a,'10:20:30') FROM t1;
 TIME'10:20:30' IN (a,'10:20:30')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIME'10:20:30' IN (a,'10:20:30',NULL) FROM t1;
 TIME'10:20:30' IN (a,'10:20:30',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIME'10:20:30' NOT IN (a,'10:20:30') FROM t1;
 TIME'10:20:30' NOT IN (a,'10:20:30')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIME'10:20:30' NOT IN (a,'10:20:30',NULL) FROM t1;
 TIME'10:20:30' NOT IN (a,'10:20:30',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 CREATE TABLE t1 (a DATETIME);
 SELECT TIMESTAMP'2001-01-01 10:20:30' IN (a,TIMESTAMP'2001-01-01 10:20:30') FROM t1;
 TIMESTAMP'2001-01-01 10:20:30' IN (a,TIMESTAMP'2001-01-01 10:20:30')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIMESTAMP'2001-01-01 10:20:30' IN (a,TIMESTAMP'2001-01-01 10:20:30',NULL) FROM t1;
 TIMESTAMP'2001-01-01 10:20:30' IN (a,TIMESTAMP'2001-01-01 10:20:30',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIMESTAMP'2001-01-01 10:20:30' NOT IN (a,TIMESTAMP'2001-01-01 10:20:30') FROM t1;
 TIMESTAMP'2001-01-01 10:20:30' NOT IN (a,TIMESTAMP'2001-01-01 10:20:30')
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 SELECT TIMESTAMP'2001-01-01 10:20:30' NOT IN (a,TIMESTAMP'2001-01-01 10:20:30',NULL) FROM t1;
 TIMESTAMP'2001-01-01 10:20:30' NOT IN (a,TIMESTAMP'2001-01-01 10:20:30',NULL)
 Warnings:
+Warning	1105	[0] arg=1 handler=0
+Warning	1105	[1] arg=2 handler=0
 Warning	1105	types_compatible=yes bisect=no
 DROP TABLE t1;
 # Constant predicant, incompatible types, no bisect
